/*
	keymap.c			pm 1/13/86

	scan code to ascii keymap for use in microEmacs on ST520

*/

#include "keynames.h"

static
char	unsh[128] = {
	/* -------scan codes: 0x00-0x0f ---------------------------- */
	'\000' /*nul*/, '\033' /*esc*/, 	
	'\061' /*1*/, '\062' /*2*/, '\063' /*3*/,
	'\064' /*4*/, '\065' /*5*/, '\066' /*6*/, '\067' /*7*/,
	'\070' /*8*/, '\071' /*9*/, '\060' /*0*/, 
	'\055' /*-*/, '\075' /*=*/,
	'\010' /* bs*/, '\011' /* ht*/, 

	/* ------------------ 0x10-0x1f ---------------------------- */
	'\161' /*q*/, '\167' /*w*/, '\145' /*e*/, '\162' /*r*/,
	'\164' /*t*/, '\171' /*y*/, '\165' /*u*/, '\151' /*i*/,
	'\157' /*o*/, '\160' /*p*/,
	'\133' /*[*/, '\135' /*]*/, 
	'\015' /* cr*/, '\000' /*ctrl*/,
	'\141' /*a*/, '\163' /*s*/, 

	/* ------------------ 0x20-0x2f ---------------------------- */
	'\144' /*d*/, '\146' /*f*/, '\147' /*g*/, '\150' /*h*/,
	'\152' /*j*/, '\153' /*k*/, '\154' /*l*/,
	'\073' /*;*/, '\047' /*'*/, '\140' /*`*/,
	'\000' /*lshift*/,
	'\134' /*\*/,
	'\172' /*z*/, '\170' /*x*/, '\143' /*c*/,  '\166' /*v*/,

	/* ------------------ 0x30-0x3f ---------------------------- */
	'\142' /*b*/, '\156' /*n*/, '\155' /*m*/,
	'\054' /*,*/, '\056' /*.*/, '\057' /* / */,
	'\000' /*rshift*/, '\000' /*unused*/, '\000' /*alt*/,
	'\040' /*space*/,
	'\000' /*caps lock*/,
	F1, F2, F3, F4, F5,


	/* ------------------ 0x40-0x4f ---------------------------- */
	F6, F7, F8, F9, F10,
	'\000' /*unused*/, '\000' /*unused*/,
	HOME,	UPARRO,	'\000' /*unused*/,
	KMINUS,	LTARRO,	'\000' /*unused*/,
	RTARRO,	KPLUS,	'\000' /*unused*/,

	/* ------------------ 0x50-0x5f ---------------------------- */
	DNARRO,	'\000' /*unused*/,	INSERT,	'\177' /*del*/,
	'\000' /*unused*/,'\000' /*unused*/,'\000' /*unused*/,
	'\000' /*unused*/,'\000' /*unused*/,'\000' /*unused*/,
	'\000' /*unused*/,'\000' /*unused*/,'\000' /*unused*/,
	'\000' /*unused*/,'\000' /*unused*/,'\000' /*unused*/,

	/* ------------------ 0x60-0x6f ---------------------------- */
	'\000' /*ISO key*/,
	UNDO,	HELP,	KLP,	KRP,	KSLASH,	KSTAR,
	K7,	K8,	K9,	K4,	K5,	K6,
	K1,	K2,	K3,

	/* ------------------ 0x70-0x72 ---------------------------- */
	K0,	KDOT,	KENTER,

	/* ------------------ 0x73-0x7f  undefined ----------------- */

};


static
char	shif[128] = {
	/* ------------------ 0x00-0x0f ---------------------------- */
	'\000' /*nul*/, '\033' /*esc*/, 	
	'\041' /*!*/, '\100' /*@*/,  '\043' /*#*/, '\044' /*$*/,
	'\045' /*%*/, '\136' /*^*/, '\046' /*&*/, '\052' /***/,
	'\050' /*(*/, '\051' /*)*/, '\137' /*_*/, '\053' /*+*/,
	'\010' /* bs*/, '\011' /* ht*/, 

	/* ------------------ 0x10-0x1f ---------------------------- */
	'\121' /*Q*/, '\127' /*W*/, '\105' /*E*/, '\122' /*R*/,
	'\124' /*T*/, '\131' /*Y*/, '\125' /*U*/, '\111' /*I*/,
	'\117' /*O*/, '\120' /*P*/,
	'\173' /*{*/, '\175' /*}*/, 
	'\015' /* cr*/, '\000' /*ctrl*/,
	'\101' /*A*/, '\123' /*S*/, 

	/* ------------------ 0x20-0x2f ---------------------------- */
	'\104' /*D*/, '\106' /*F*/, '\107' /*G*/, '\110' /*H*/,
	'\112' /*J*/, '\113' /*K*/, '\114' /*L*/,
	'\072' /*:*/, '\042' /*"*/, '\176' /*~*/,
	'\000' /*lshift*/,
	'\174' /*|*/,
	'\132' /*Z*/, '\130' /*X*/, '\103' /*C*/,  '\126' /*V*/,

	/* ------------------ 0x30-0x3f ---------------------------- */
	'\102' /*B*/, '\116' /*N*/, '\115' /*M*/,
	'\074' /*<*/, '\076' /*.*/, '\077' /* ? */,
	'\000' /*rshift*/, '\000' /*unused*/, '\000' /*alt*/,
	'\040' /*space*/,
	'\000' /*caps lock*/,
	F1+SHIFTED, F2+SHIFTED, F3+SHIFTED, F4+SHIFTED, F5+SHIFTED,


	/* ------------------ 0x40-0x4f ---------------------------- */
	F6+SHIFTED, F7+SHIFTED, F8+SHIFTED, F9+SHIFTED, F10+SHIFTED,
	'\000' /*unused*/, '\000' /*unused*/,
	HOME+SHIFTED,	UPARRO+SHIFTED,	'\000' /*unused*/,
	KMINUS+SHIFTED,LTARRO+SHIFTED,	'\000' /*unused*/,
	RTARRO+SHIFTED,KPLUS+SHIFTED,	'\000' /*unused*/,

	/* ------------------ 0x50-0x5f ---------------------------- */
	DNARRO+SHIFTED,	'\000' /*unused*/,
	INSERT+SHIFTED,	'\177' /*del*/,
	'\000' /*unused*/,'\000' /*unused*/,'\000' /*unused*/,
	'\000' /*unused*/,'\000' /*unused*/,'\000' /*unused*/,
	'\000' /*unused*/,'\000' /*unused*/,'\000' /*unused*/,
	'\000' /*unused*/,'\000' /*unused*/,'\000' /*unused*/,

	/* ------------------ 0x60-0x6f ---------------------------- */
	'\000' /*ISO key*/,
	UNDO+SHIFTED,	HELP+SHIFTED,	KLP+SHIFTED,
	KRP+SHIFTED,	KSLASH+SHIFTED,KSTAR+SHIFTED,
	K7+SHIFTED,	K8+SHIFTED,	K9+SHIFTED,
	K4+SHIFTED,	K5+SHIFTED,	K6+SHIFTED,
	K1+SHIFTED,	K2+SHIFTED,	K3+SHIFTED,

	/* ------------------ 0x70-0x72 ---------------------------- */
	K0+SHIFTED,	KDOT+SHIFTED,	KENTER+SHIFTED,

	/* ------------------ 0x73-0x7f  undefined ----------------- */

};

static
char	caps[128] = {
	/* ------------------ 0x00-0x0f ---------------------------- */
	'\000' /*nul*/, '\033' /*esc*/, 	
	'\061' /*1*/, '\062' /*2*/, '\063' /*3*/,
	'\064' /*4*/, '\065' /*5*/, '\066' /*6*/, '\067' /*7*/,
	'\070' /*8*/, '\071' /*9*/, '\060' /*0*/, 
	'\055' /*-*/, '\075' /*=*/,
	'\010' /* bs*/, '\011' /* ht*/, 

	/* ------------------ 0x10-0x1f ---------------------------- */
	'\121' /*Q*/, '\127' /*W*/, '\105' /*E*/, '\122' /*R*/,
	'\124' /*T*/, '\131' /*Y*/, '\125' /*U*/, '\111' /*I*/,
	'\117' /*O*/, '\120' /*P*/,
	'\133' /*[*/, '\135' /*]*/, 
	'\015' /* cr*/, '\000' /*ctrl*/,
	'\101' /*A*/, '\123' /*S*/, 

	/* ------------------ 0x20-0x2f ---------------------------- */
	'\104' /*D*/, '\106' /*F*/, '\107' /*G*/, '\110' /*H*/,
	'\112' /*J*/, '\113' /*K*/, '\114' /*L*/,
	'\073' /*;*/, '\047' /*'*/, '\140' /*`*/,
	'\000' /*lshift*/,
	'\134' /*\*/,
	'\132' /*Z*/, '\130' /*X*/, '\103' /*C*/,  '\126' /*V*/,

	/* ------------------ 0x30-0x3f ---------------------------- */
	'\102' /*B*/, '\116' /*N*/, '\115' /*M*/,
	'\054' /*,*/, '\056' /*.*/, '\057' /* / */,
	'\000' /*rshift*/, '\000' /*unused*/, '\000' /*alt*/,
	'\040' /*space*/,
	'\000' /*caps lock*/,
	F1, F2, F3, F4, F5,


	/* ------------------ 0x40-0x4f ---------------------------- */
	F6, F7, F8, F9, F10,
	'\000' /*unused*/, '\000' /*unused*/,
	HOME,	UPARRO,	'\000' /*unused*/,
	KMINUS,	LTARRO,	'\000' /*unused*/,
	RTARRO,	KPLUS,	'\000' /*unused*/,

	/* ------------------ 0x50-0x5f ---------------------------- */
	DNARRO,	'\000' /*unused*/,	INSERT,	'\177' /*del*/,
	'\000' /*unused*/,'\000' /*unused*/,'\000' /*unused*/,
	'\000' /*unused*/,'\000' /*unused*/,'\000' /*unused*/,
	'\000' /*unused*/,'\000' /*unused*/,'\000' /*unused*/,
	'\000' /*unused*/,'\000' /*unused*/,'\000' /*unused*/,

	/* ------------------ 0x60-0x6f ---------------------------- */
	'\000' /*ISO key*/,
	UNDO,	HELP,	KLP,	KRP,	KSLASH,	KSTAR,
	K7,	K8,	K9,	K4,	K5,	K6,
	K1,	K2,	K3,

	/* ------------------ 0x70-0x72 ---------------------------- */
	K0,	KDOT,	KENTER,

	/* ------------------ 0x73-0x7f  undefined ----------------- */

};

#include "osbind.h"

keysetup()
{
	Keytbl(unsh, shif, caps);
	/* The ptr this returns appears to be useless	*/
	/* It should return the ptrs to old tables	*/
}


keyreset()			/* should reset to the table we had	*/
{				/* prior to entering uE			*/
	Bioskeys();
}

/* -eof- */
